ApplicationModel subclass: #LANInterface
	instanceVariableNames: 'nodeName nodeList nextNode deviceNameMenu contents originator addressee '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!LANInterface methodsFor: 'private'!

addresseesMenu

	| menuBuilder |
	menuBuilder := MenuBuilder new.
	self nodeList list do: [:each | each canOutput ifTrue: [menuBuilder add: each name -> each]].
	^menuBuilder menu!

originatorsMenu

	| menuBuilder |
	menuBuilder := MenuBuilder new.
	self nodeList list do: [:each | each canOriginate ifTrue: [menuBuilder add: each name -> each]].
	^menuBuilder menu! !

!LANInterface methodsFor: 'actions'!

accept

	"This stub method was generated by UIDefiner"

	^self!

cancel

	"This stub method was generated by UIDefiner"

	^self!

changedNode

	| newMenu |
	newMenu := MenuBuilder new.
	self nodeList list do: [:node | newMenu add: node name->node].
	self deviceNameMenu setValue: newMenu menu!

newFileServer

	^self nodeList list add: FileServer new!

newNode

	^self nodeList list add: Node new!

newPrintServer

	^self nodeList list add: PrintServer new!

newWorkstation

	^self nodeList list add: WorkStation new!

originate

	| dialogModel dialogBuilder returnVal packet dialogOriginator dialogAddressee dialogContents |
	"the next three lines create ValueHolders to support the three dialog widgets"
	dialogOriginator := nil asValue.
	dialogAddressee := nil asValue.
	dialogContents := String new asValue.
	"next two lines create a new SimpleDialog object and retrieves the builder"
	dialogModel := SimpleDialog new.
	dialogBuilder := dialogModel builder.
	"the following lines connect  the widgets of the interface with the ValueHolders created"
	dialogBuilder aspectAt: #originator put: dialogOriginator.
	dialogBuilder aspectAt: #addressee put: dialogAddressee.
	dialogBuilder aspectAt: #contents put: dialogContents.
	"the following lines ask the LANInterface for the originators and outputters menus. 
	You will write these next, so select proceed when VisualWorks when VisualWorks indicates that they are new messages."
	dialogBuilder aspectAt: #originators put: self originatorsMenu.
	dialogBuilder aspectAt: #addressees put: self addresseesMenu.
	"the following line actually opens the dialog interface, originateDialog, and accepts user input"
	returnVal := dialogModel openFor: self interface: #originateDialog.
	"returnvalue will be true if the user selected Accept, otherwise it will be false"
	returnVal ifTrue: [
		"create a new packet, fill it in and give it to the workstation"
		packet := Packet new addressee: (SingleDestinationAddress new id: dialogAddressee value name); contents: dialogContents value. 
		dialogOriginator value originate: packet]!

remove

	| sel |
	(sel := self nodeList selection) isNil
		ifFalse: [self nodeList list remove: sel].
	self changedNode! !

!LANInterface methodsFor: 'aspects'!

addressee
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^addressee isNil
		ifTrue:
			[addressee := nil asValue]
		ifFalse:
			[addressee]!

contents
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^contents isNil
		ifTrue:
			[contents := String new asValue]
		ifFalse:
			[contents]!

deviceNameMenu

	^deviceNameMenu isNil 
		ifTrue: [deviceNameMenu := Menu new asValue]
		ifFalse: [deviceNameMenu]!

nextNode
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^nextNode isNil
		ifTrue:
			[nextNode := nil asValue]
		ifFalse:
			[nextNode]!

nodeList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^nodeList isNil
		ifTrue:
			[nodeList := SelectionInList new]
		ifFalse:
			[nodeList]!

nodeName
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^nodeName isNil
		ifTrue:
			[nodeName := nil asValue]
		ifFalse:
			[nodeName]!

originator
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^originator isNil
		ifTrue:
			[originator := nil asValue]
		ifFalse:
			[originator]! !

!LANInterface methodsFor: 'initialize-release'!

initialize

	| selectionHolder |
	super initialize.
	self nodeList list: DependentList new.
	selectionHolder := self nodeList selectionHolder.
	nodeName := (AspectAdaptor forAspect: #name)
		subjectChannel: selectionHolder.
	nextNode := (AspectAdaptor forAspect: #nextNode)
		subjectChannel: selectionHolder;
		subjectSendsUpdates: true.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LANInterface class
	instanceVariableNames: ''!


!LANInterface class methodsFor: 'interface specs'!

originateDialog
	"UIPainter new openOnClass: self andSelector: #originateDialog"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Originate' 
			#bounds: #(#Rectangle 301 390 587 741 ) 
			#flags: 8 ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#AlignmentOrigin 0 0.5 2 0 0.5 0 ) 
					#label: 'Originate a new packet' ) 
				#(#LabelSpec 
					#layout: #(#Point 3 30 ) 
					#label: 'Originator' ) 
				#(#LabelSpec 
					#layout: #(#Point 3 95 ) 
					#label: 'Addressee' ) 
				#(#LabelSpec 
					#layout: #(#Point 3 160 ) 
					#label: 'Contents' ) 
				#(#MenuButtonSpec 
					#layout: #(#LayoutFrame 10 0 55 0 -10 1 80 0 ) 
					#model: #originator 
					#menu: #originators ) 
				#(#MenuButtonSpec 
					#layout: #(#LayoutFrame 10 0 120 0 -10 1 145 0 ) 
					#model: #addressee 
					#menu: #addressees ) 
				#(#TextEditorSpec 
					#layout: #(#LayoutFrame 10 0 185 0 -10 1 -40 1 ) 
					#model: #contents ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame 20 0 -30 1 -50 0.5 -3 1 ) 
					#model: #accept 
					#label: 'Accept' ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame 50 0.5 -30 1 -20 1 -3 1 ) 
					#model: #cancel 
					#label: 'Cancel' ) ) ) )!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Local Area Network' 
			#bounds: #(#Rectangle 189 174 816 582 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#GroupBoxSpec 
					#layout: #(#LayoutFrame 5 0 0 0 -120 1 50 0 ) 
					#label: 'Create' ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 20 20 120 45 ) 
					#model: #newWorkstation 
					#label: 'Workstation' ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 140 20 240 45 ) 
					#model: #newNode 
					#label: 'Node' ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 260 20 360 45 ) 
					#model: #newPrintServer 
					#label: 'PrintServer' ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 380 20 480 45 ) 
					#model: #newFileServer 
					#label: 'FileServer' ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame -105 1 20 0 -5 1 45 0 ) 
					#name: #removeButton 
					#model: #remove 
					#label: 'Remove' ) 
				#(#SequenceViewSpec 
					#layout: #(#LayoutFrame 5 0 60 0 -5 1 -130 1 ) 
					#name: #nodeList 
					#flags: 15 
					#model: #nodeList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#LabelSpec 
					#layout: #(#LayoutOrigin 5 0 -110 1 ) 
					#label: 'Name:' ) 
				#(#LabelSpec 
					#layout: #(#LayoutOrigin 5 0 -75 1 ) 
					#label: 'Next Node:' ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame -50 0.5 -30 1 50 0.5 -5 1 ) 
					#name: #originateButton 
					#model: #originate 
					#label: 'Originate' ) 
				#(#InputFieldSpec 
					#layout: #(#LayoutFrame 80 0 -110 1 300 0 -85 1 ) 
					#name: #nodeName 
					#model: #nodeName 
					#callbacksSpec: 
					#(#UIEventCallbackSubSpec 
						#valueChangeSelector: #changedNode ) 
					#type: #symbol ) 
				#(#MenuButtonSpec 
					#layout: #(#LayoutFrame 80 0 -75 1 300 0 -50 1 ) 
					#name: #nextNodeMenu 
					#model: #nextNode 
					#callbacksSpec: 
					#(#UIEventCallbackSubSpec 
						#valueChangeSelector: #changedNode ) 
					#menu: #deviceNameMenu ) ) ) )! !

Model subclass: #Node
	instanceVariableNames: 'name nextNode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!Node methodsFor: 'testing'!

canOriginate

	^false!

canOutput

	^false! !

!Node methodsFor: 'initialize-release'!

initialize
	"This is the default initialize method that is always called when new instances are created. My 
	subclasses will likely override this method to be initialized."

	"I just set my name to unnamed"

	self name: #Unnamed! !

!Node methodsFor: 'accessing'!

name
	"returns the name of the node"

	^name!

name: aSymbol
	"sets the name of the node (a Symbol)"

	name := aSymbol.
	self changed: #name!

nextNode
	"return the next node of the receiver"

	^nextNode!

nextNode: aNode
	"set the next node of the receiver to be aNode"

	nextNode := aNode.
	self changed: #nextNode! !

!Node methodsFor: 'sending-receiving'!

accept: thePacket
	"Having received the packet, send it on. This is the default behavior."
	"My subclasses will probably override this method to do something special"

	self send: thePacket!

send: thePacket 
	"Display debug information in the Transcript, then send the packet to the node which whom I 
	communicate"

	Transcript show: self name printString , ' sending the packet to ' , self nextNode name printString; cr.
	self nextNode accept: thePacket! !

!Node methodsFor: 'printing'!

printOn: aStream
	"print a textual representation of myself on the argument, aStream"

	super printOn: aStream.
	aStream nextPutAll: ': ',self name asString.
	self nextNode isNil ifFalse: [aStream nextPutAll: ', pointing to ',self nextNode name printString]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Node class
	instanceVariableNames: ''!


!Node class methodsFor: 'instance creation'!

new

	^super new initialize! !

Object subclass: #AbstractDestinationAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!AbstractDestinationAddress methodsFor: 'comparing'!

isDestinationFor: aNodeAddress

	^self subclassResponsibility! !

AbstractDestinationAddress subclass: #SingleDestinationAddress
	instanceVariableNames: 'id '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!SingleDestinationAddress methodsFor: 'comparing'!

equalsMultiple: aSingleNodeAddress

	^self halt!

equalsSingle: aSingleNodeAddress

	^self id = aSingleNodeAddress id!

isDestinationFor: aNodeAddress

	^aNodeAddress equalsSingle: self! !

!SingleDestinationAddress methodsFor: 'accessing'!

id

	^id!

id: aSymbol

	id := aSymbol! !

Node subclass: #WorkStation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!WorkStation methodsFor: 'sending-receiving'!

accept: thePacket 
	"accept the packet and see if I am the originator. If this is the case, take the packet out because the 
	addressee is unknown. Print this on the Transcript"

	thePacket originator = self
		ifTrue: [Transcript show: 'The receiver of following packet does not exist:'; cr; show: thePacket printString; cr]
		ifFalse: [self send: thePacket]!

originate: thePacket 
	"This is how packets get inserted into the network. This is a likely method to be rwritten to permit 
	packets to be entered in various ways. Currently, I assume that someone alse creates the packet, 
	and passes it to me as an argument."

	thePacket originator: self.
	self send: thePacket! !

!WorkStation methodsFor: 'testing'!

canOriginate

	^true! !

Node subclass: #OutputServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!OutputServer methodsFor: 'outputting'!

output: thePacket
	"My subclasses have to use this method to define their outputting behavior"

	self subclassResponsibility! !

!OutputServer methodsFor: 'sending-receiving'!

accept: thePacket 
	"I first see if the packet is for me. If it is, I output it. Otherwise, I pass it on"

	(thePacket addressee isDestinationFor: self name) 	"self name = thePacket addressee"
		ifTrue: [self output: thePacket]
		ifFalse: [self send: thePacket]! !

!OutputServer methodsFor: 'testing'!

canOutput

	^true! !

OutputServer subclass: #FileServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!FileServer methodsFor: 'outputting'!

output: thePacket 
	"My subclasses have to use this method to define their outputting behavior"

	Transcript cr.
	Transcript show: 'FileServer ' , self name printString , ' saves ' , thePacket contents! !

Object subclass: #Packet
	instanceVariableNames: 'contents addressee originator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!Packet methodsFor: 'printing'!

printOn: aStream 

	super printOn: aStream.
	self originator notNil ifTrue: [aStream nextPutAll: ' coming from ' , self originator name printString].
	aStream nextPutAll:
		' addressed to ' , self addressee printString , 
		' with contents: ' , self contents! !

!Packet methodsFor: 'accessing'!

addressee
	"return the name of the node that is the addressee for this packet"

	^addressee!

addressee: anAddress
	"set the name of the node that is the addressee for this packet"

	addressee := anAddress.
	self changed: #addressee!

contents
	"return the contents of the receiver"

	^contents!

contents: aString
	"set the contents of the receiver"

	contents := aString.
	self changed: #contents!

originator
	"I return the originator of the receiver"

	^originator!

originator: aNode
	"Set the originator of the receiver"

	originator := aNode.
	self changed: #originator! !

OutputServer subclass: #PrintServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Demo-LAN'!


!PrintServer methodsFor: 'outputting'!

output: thePacket 
	"My subclasses have to use this method to define their outputting behavior"

	Transcript cr.
	80 timesRepeat: [Transcript show: '-'].
	Transcript cr.
	Transcript show: 'Printer ' , self name printString , ' prints ' , thePacket contents! !

